aboutsummaryrefslogtreecommitdiffstats
path: root/tests/bandwidth-client
diff options
context:
space:
mode:
authorJonathan McCrohan <jmccrohan@gmail.com>2011-10-12 21:50:48 +0100
committerJonathan McCrohan <jmccrohan@gmail.com>2011-10-12 21:50:48 +0100
commit6cfbf2dee130cc36a72d57adea0e9c04bb31f620 (patch)
tree638bcaf4c63e3d3be17e0f5e7d74639394d15702 /tests/bandwidth-client
downloadverteco-6cfbf2dee130cc36a72d57adea0e9c04bb31f620.tar.gz
Initial commit
Diffstat (limited to '')
-rwxr-xr-xtests/bandwidth-client225
-rw-r--r--tests/bandwidth-client.c220
-rw-r--r--tests/bandwidth-client.obin0 -> 22288 bytes
3 files changed, 445 insertions, 0 deletions
diff --git a/tests/bandwidth-client b/tests/bandwidth-client
new file mode 100755
index 0000000..b013803
--- /dev/null
+++ b/tests/bandwidth-client
@@ -0,0 +1,225 @@
+#! /bin/bash
+
+# bandwidth-client - temporary wrapper script for .libs/bandwidth-client
+# Generated by libtool (GNU libtool) 2.4 Debian-2.4-3
+#
+# The bandwidth-client program cannot be directly executed until all the libtool
+# libraries that it depends on are installed.
+#
+# This wrapper script should never be moved out of the build directory.
+# If it is, it will not operate correctly.
+
+# Sed substitution that helps us do robust quoting. It backslashifies
+# metacharacters that are still active within double-quoted strings.
+sed_quote_subst='s/\([`"$\\]\)/\\\1/g'
+
+# Be Bourne compatible
+if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
+ emulate sh
+ NULLCMD=:
+ # Zsh 3.x and 4.x performs word splitting on ${1+"$@"}, which
+ # is contrary to our usage. Disable this feature.
+ alias -g '${1+"$@"}'='"$@"'
+ setopt NO_GLOB_SUBST
+else
+ case `(set -o) 2>/dev/null` in *posix*) set -o posix;; esac
+fi
+BIN_SH=xpg4; export BIN_SH # for Tru64
+DUALCASE=1; export DUALCASE # for MKS sh
+
+# The HP-UX ksh and POSIX shell print the target directory to stdout
+# if CDPATH is set.
+(unset CDPATH) >/dev/null 2>&1 && unset CDPATH
+
+relink_command="(cd /home/jmccrohan/bin/libmodbus/tests; { test -z \"\${LIBRARY_PATH+set}\" || unset LIBRARY_PATH || { LIBRARY_PATH=; export LIBRARY_PATH; }; }; { test -z \"\${COMPILER_PATH+set}\" || unset COMPILER_PATH || { COMPILER_PATH=; export COMPILER_PATH; }; }; { test -z \"\${GCC_EXEC_PREFIX+set}\" || unset GCC_EXEC_PREFIX || { GCC_EXEC_PREFIX=; export GCC_EXEC_PREFIX; }; }; { test -z \"\${LD_RUN_PATH+set}\" || unset LD_RUN_PATH || { LD_RUN_PATH=; export LD_RUN_PATH; }; }; { test -z \"\${LD_LIBRARY_PATH+set}\" || unset LD_LIBRARY_PATH || { LD_LIBRARY_PATH=; export LD_LIBRARY_PATH; }; }; PATH=/usr/sbin:/usr/bin:/sbin:/bin:/usr/bin/X11; export PATH; gcc -g -O2 -g -O2 -Wall -Werror -o \$progdir/\$file bandwidth-client.o ../src/.libs/libmodbus.so -Wl,-rpath -Wl,/home/jmccrohan/bin/libmodbus/src/.libs)"
+
+# This environment variable determines our operation mode.
+if test "$libtool_install_magic" = "%%%MAGIC variable%%%"; then
+ # install mode needs the following variables:
+ generated_by_libtool_version='2.4'
+ notinst_deplibs=' ../src/libmodbus.la'
+else
+ # When we are sourced in execute mode, $file and $ECHO are already set.
+ if test "$libtool_execute_magic" != "%%%MAGIC variable%%%"; then
+ file="$0"
+
+# A function that is used when there is no print builtin or printf.
+func_fallback_echo ()
+{
+ eval 'cat <<_LTECHO_EOF
+$1
+_LTECHO_EOF'
+}
+ ECHO="printf %s\\n"
+ fi
+
+# Very basic option parsing. These options are (a) specific to
+# the libtool wrapper, (b) are identical between the wrapper
+# /script/ and the wrapper /executable/ which is used only on
+# windows platforms, and (c) all begin with the string --lt-
+# (application programs are unlikely to have options which match
+# this pattern).
+#
+# There are only two supported options: --lt-debug and
+# --lt-dump-script. There is, deliberately, no --lt-help.
+#
+# The first argument to this parsing function should be the
+# script's ../libtool value, followed by no.
+lt_option_debug=
+func_parse_lt_options ()
+{
+ lt_script_arg0=$0
+ shift
+ for lt_opt
+ do
+ case "$lt_opt" in
+ --lt-debug) lt_option_debug=1 ;;
+ --lt-dump-script)
+ lt_dump_D=`$ECHO "X$lt_script_arg0" | /bin/sed -e 's/^X//' -e 's%/[^/]*$%%'`
+ test "X$lt_dump_D" = "X$lt_script_arg0" && lt_dump_D=.
+ lt_dump_F=`$ECHO "X$lt_script_arg0" | /bin/sed -e 's/^X//' -e 's%^.*/%%'`
+ cat "$lt_dump_D/$lt_dump_F"
+ exit 0
+ ;;
+ --lt-*)
+ $ECHO "Unrecognized --lt- option: '$lt_opt'" 1>&2
+ exit 1
+ ;;
+ esac
+ done
+
+ # Print the debug banner immediately:
+ if test -n "$lt_option_debug"; then
+ echo "bandwidth-client:bandwidth-client:${LINENO}: libtool wrapper (GNU libtool) 2.4 Debian-2.4-3" 1>&2
+ fi
+}
+
+# Used when --lt-debug. Prints its arguments to stdout
+# (redirection is the responsibility of the caller)
+func_lt_dump_args ()
+{
+ lt_dump_args_N=1;
+ for lt_arg
+ do
+ $ECHO "bandwidth-client:bandwidth-client:${LINENO}: newargv[$lt_dump_args_N]: $lt_arg"
+ lt_dump_args_N=`expr $lt_dump_args_N + 1`
+ done
+}
+
+# Core function for launching the target application
+func_exec_program_core ()
+{
+
+ if test -n "$lt_option_debug"; then
+ $ECHO "bandwidth-client:bandwidth-client:${LINENO}: newargv[0]: $progdir/$program" 1>&2
+ func_lt_dump_args ${1+"$@"} 1>&2
+ fi
+ exec "$progdir/$program" ${1+"$@"}
+
+ $ECHO "$0: cannot exec $program $*" 1>&2
+ exit 1
+}
+
+# A function to encapsulate launching the target application
+# Strips options in the --lt-* namespace from $@ and
+# launches target application with the remaining arguments.
+func_exec_program ()
+{
+ for lt_wr_arg
+ do
+ case $lt_wr_arg in
+ --lt-*) ;;
+ *) set x "$@" "$lt_wr_arg"; shift;;
+ esac
+ shift
+ done
+ func_exec_program_core ${1+"$@"}
+}
+
+ # Parse options
+ func_parse_lt_options "$0" ${1+"$@"}
+
+ # Find the directory that this script lives in.
+ thisdir=`$ECHO "$file" | /bin/sed 's%/[^/]*$%%'`
+ test "x$thisdir" = "x$file" && thisdir=.
+
+ # Follow symbolic links until we get to the real thisdir.
+ file=`ls -ld "$file" | /bin/sed -n 's/.*-> //p'`
+ while test -n "$file"; do
+ destdir=`$ECHO "$file" | /bin/sed 's%/[^/]*$%%'`
+
+ # If there was a directory component, then change thisdir.
+ if test "x$destdir" != "x$file"; then
+ case "$destdir" in
+ [\\/]* | [A-Za-z]:[\\/]*) thisdir="$destdir" ;;
+ *) thisdir="$thisdir/$destdir" ;;
+ esac
+ fi
+
+ file=`$ECHO "$file" | /bin/sed 's%^.*/%%'`
+ file=`ls -ld "$thisdir/$file" | /bin/sed -n 's/.*-> //p'`
+ done
+
+ # Usually 'no', except on cygwin/mingw when embedded into
+ # the cwrapper.
+ WRAPPER_SCRIPT_BELONGS_IN_OBJDIR=no
+ if test "$WRAPPER_SCRIPT_BELONGS_IN_OBJDIR" = "yes"; then
+ # special case for '.'
+ if test "$thisdir" = "."; then
+ thisdir=`pwd`
+ fi
+ # remove .libs from thisdir
+ case "$thisdir" in
+ *[\\/].libs ) thisdir=`$ECHO "$thisdir" | /bin/sed 's%[\\/][^\\/]*$%%'` ;;
+ .libs ) thisdir=. ;;
+ esac
+ fi
+
+ # Try to get the absolute directory name.
+ absdir=`cd "$thisdir" && pwd`
+ test -n "$absdir" && thisdir="$absdir"
+
+ program=lt-'bandwidth-client'
+ progdir="$thisdir/.libs"
+
+ if test ! -f "$progdir/$program" ||
+ { file=`ls -1dt "$progdir/$program" "$progdir/../$program" 2>/dev/null | /bin/sed 1q`; \
+ test "X$file" != "X$progdir/$program"; }; then
+
+ file="$$-$program"
+
+ if test ! -d "$progdir"; then
+ mkdir "$progdir"
+ else
+ rm -f "$progdir/$file"
+ fi
+
+ # relink executable if necessary
+ if test -n "$relink_command"; then
+ if relink_command_output=`eval $relink_command 2>&1`; then :
+ else
+ printf %s\n "$relink_command_output" >&2
+ rm -f "$progdir/$file"
+ exit 1
+ fi
+ fi
+
+ mv -f "$progdir/$file" "$progdir/$program" 2>/dev/null ||
+ { rm -f "$progdir/$program";
+ mv -f "$progdir/$file" "$progdir/$program"; }
+ rm -f "$progdir/$file"
+ fi
+
+ if test -f "$progdir/$program"; then
+ if test "$libtool_execute_magic" != "%%%MAGIC variable%%%"; then
+ # Run the actual program with our arguments.
+ func_exec_program ${1+"$@"}
+ fi
+ else
+ # The program doesn't exist.
+ $ECHO "$0: error: \`$progdir/$program' does not exist" 1>&2
+ $ECHO "This script is just a wrapper for $program." 1>&2
+ $ECHO "See the libtool documentation for more information." 1>&2
+ exit 1
+ fi
+fi
diff --git a/tests/bandwidth-client.c b/tests/bandwidth-client.c
new file mode 100644
index 0000000..e9109e1
--- /dev/null
+++ b/tests/bandwidth-client.c
@@ -0,0 +1,220 @@
+/*
+ * Copyright © 2008-2010 Stéphane Raimbault <stephane.raimbault@gmail.com>
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <stdio.h>
+#include <unistd.h>
+#include <string.h>
+#include <stdlib.h>
+#include <time.h>
+#include <sys/time.h>
+#include <errno.h>
+
+#include <modbus.h>
+
+#define G_MSEC_PER_SEC 1000
+
+uint32_t gettime_ms(void)
+{
+ struct timeval tv;
+ gettimeofday (&tv, NULL);
+
+ return (uint32_t) tv.tv_sec * 1000 + tv.tv_usec / 1000;
+}
+
+enum {
+ TCP,
+ RTU
+};
+
+/* Tests based on PI-MBUS-300 documentation */
+int main(int argc, char *argv[])
+{
+ uint8_t *tab_bit;
+ uint16_t *tab_reg;
+ modbus_t *ctx;
+ int i;
+ int nb_points;
+ double elapsed;
+ uint32_t start;
+ uint32_t end;
+ uint32_t bytes;
+ uint32_t rate;
+ int rc;
+ int n_loop;
+ int use_backend;
+
+ if (argc > 1) {
+ if (strcmp(argv[1], "tcp") == 0) {
+ use_backend = TCP;
+ n_loop = 100000;
+ } else if (strcmp(argv[1], "rtu") == 0) {
+ use_backend = RTU;
+ n_loop = 100;
+ } else {
+ printf("Usage:\n %s [tcp|rtu] - Modbus client to measure data bandwith\n\n", argv[0]);
+ exit(1);
+ }
+ } else {
+ /* By default */
+ use_backend = TCP;
+ n_loop = 100000;
+ }
+
+ if (use_backend == TCP) {
+ ctx = modbus_new_tcp("127.0.0.1", 1502);
+ } else {
+ ctx = modbus_new_rtu("/dev/ttyUSB1", 115200, 'N', 8, 1);
+ modbus_set_slave(ctx, 1);
+ }
+ if (modbus_connect(ctx) == -1) {
+ fprintf(stderr, "Connexion failed: %s\n",
+ modbus_strerror(errno));
+ modbus_free(ctx);
+ return -1;
+ }
+
+ /* Allocate and initialize the memory to store the status */
+ tab_bit = (uint8_t *) malloc(MODBUS_MAX_READ_BITS * sizeof(uint8_t));
+ memset(tab_bit, 0, MODBUS_MAX_READ_BITS * sizeof(uint8_t));
+
+ /* Allocate and initialize the memory to store the registers */
+ tab_reg = (uint16_t *) malloc(MODBUS_MAX_READ_REGISTERS * sizeof(uint16_t));
+ memset(tab_reg, 0, MODBUS_MAX_READ_REGISTERS * sizeof(uint16_t));
+
+ printf("READ BITS\n\n");
+
+ nb_points = MODBUS_MAX_READ_BITS;
+ start = gettime_ms();
+ for (i=0; i<n_loop; i++) {
+ rc = modbus_read_bits(ctx, 0, nb_points, tab_bit);
+ if (rc == -1) {
+ fprintf(stderr, "%s\n", modbus_strerror(errno));
+ return -1;
+ }
+ }
+ end = gettime_ms();
+ elapsed = end - start;
+
+ rate = (n_loop * nb_points) * G_MSEC_PER_SEC / (end - start);
+ printf("Transfert rate in points/seconds:\n");
+ printf("* %d points/s\n", rate);
+ printf("\n");
+
+ bytes = n_loop * (nb_points / 8) + ((nb_points % 8) ? 1 : 0);
+ rate = bytes / 1024 * G_MSEC_PER_SEC / (end - start);
+ printf("Values:\n");
+ printf("* %d x %d values\n", n_loop, nb_points);
+ printf("* %.3f ms for %d bytes\n", elapsed, bytes);
+ printf("* %d KiB/s\n", rate);
+ printf("\n");
+
+ /* TCP: Query and reponse header and values */
+ bytes = 12 + 9 + (nb_points / 8) + ((nb_points % 8) ? 1 : 0);
+ printf("Values and TCP Modbus overhead:\n");
+ printf("* %d x %d bytes\n", n_loop, bytes);
+ bytes = n_loop * bytes;
+ rate = bytes / 1024 * G_MSEC_PER_SEC / (end - start);
+ printf("* %.3f ms for %d bytes\n", elapsed, bytes);
+ printf("* %d KiB/s\n", rate);
+ printf("\n\n");
+
+ printf("READ REGISTERS\n\n");
+
+ nb_points = MODBUS_MAX_READ_REGISTERS;
+ start = gettime_ms();
+ for (i=0; i<n_loop; i++) {
+ rc = modbus_read_registers(ctx, 0, nb_points, tab_reg);
+ if (rc == -1) {
+ fprintf(stderr, "%s\n", modbus_strerror(errno));
+ return -1;
+ }
+ }
+ end = gettime_ms();
+ elapsed = end - start;
+
+ rate = (n_loop * nb_points) * G_MSEC_PER_SEC / (end - start);
+ printf("Transfert rate in points/seconds:\n");
+ printf("* %d registers/s\n", rate);
+ printf("\n");
+
+ bytes = n_loop * nb_points * sizeof(uint16_t);
+ rate = bytes / 1024 * G_MSEC_PER_SEC / (end - start);
+ printf("Values:\n");
+ printf("* %d x %d values\n", n_loop, nb_points);
+ printf("* %.3f ms for %d bytes\n", elapsed, bytes);
+ printf("* %d KiB/s\n", rate);
+ printf("\n");
+
+ /* TCP:Query and reponse header and values */
+ bytes = 12 + 9 + (nb_points * sizeof(uint16_t));
+ printf("Values and TCP Modbus overhead:\n");
+ printf("* %d x %d bytes\n", n_loop, bytes);
+ bytes = n_loop * bytes;
+ rate = bytes / 1024 * G_MSEC_PER_SEC / (end - start);
+ printf("* %.3f ms for %d bytes\n", elapsed, bytes);
+ printf("* %d KiB/s\n", rate);
+ printf("\n\n");
+
+ printf("READ AND WRITE REGISTERS\n\n");
+
+ nb_points = MODBUS_MAX_RW_WRITE_REGISTERS;
+ start = gettime_ms();
+ for (i=0; i<n_loop; i++) {
+ rc = modbus_write_and_read_registers(ctx,
+ 0, nb_points, tab_reg,
+ 0, nb_points, tab_reg);
+ if (rc == -1) {
+ fprintf(stderr, "%s\n", modbus_strerror(errno));
+ return -1;
+ }
+ }
+ end = gettime_ms();
+ elapsed = end - start;
+
+ rate = (n_loop * nb_points) * G_MSEC_PER_SEC / (end - start);
+ printf("Transfert rate in points/seconds:\n");
+ printf("* %d registers/s\n", rate);
+ printf("\n");
+
+ bytes = n_loop * nb_points * sizeof(uint16_t);
+ rate = bytes / 1024 * G_MSEC_PER_SEC / (end - start);
+ printf("Values:\n");
+ printf("* %d x %d values\n", n_loop, nb_points);
+ printf("* %.3f ms for %d bytes\n", elapsed, bytes);
+ printf("* %d KiB/s\n", rate);
+ printf("\n");
+
+ /* TCP:Query and reponse header and values */
+ bytes = 12 + 9 + (nb_points * sizeof(uint16_t));
+ printf("Values and TCP Modbus overhead:\n");
+ printf("* %d x %d bytes\n", n_loop, bytes);
+ bytes = n_loop * bytes;
+ rate = bytes / 1024 * G_MSEC_PER_SEC / (end - start);
+ printf("* %.3f ms for %d bytes\n", elapsed, bytes);
+ printf("* %d KiB/s\n", rate);
+ printf("\n");
+
+ /* Free the memory */
+ free(tab_bit);
+ free(tab_reg);
+
+ /* Close the connection */
+ modbus_close(ctx);
+ modbus_free(ctx);
+
+ return 0;
+}
diff --git a/tests/bandwidth-client.o b/tests/bandwidth-client.o
new file mode 100644
index 0000000..9ff6b23
--- /dev/null
+++ b/tests/bandwidth-client.o
Binary files differ